# ``GRDB``

A toolkit for SQLite databases, with a focus on application development

## Overview

GRDB provides raw access to SQL and advanced SQLite features, because one sometimes enjoys a sharp tool. It has robust concurrency primitives, so that multi-threaded applications can efficiently use their databases. It grants your application models with persistence and fetching methods, so that you don't have to deal with SQL and raw database rows when you don't want to.


## Topics

### Fundamentals

- <doc:DatabaseConnections>
- <doc:SQLSupport>
- <doc:Concurrency>

### Migrations and The Database Schema

- <doc:DatabaseSchema>
- <doc:Migrations>
- <doc:SingleRowTables>

### Record Types and the Query Interface

- <doc:QueryInterface>

### Database Observation

- <doc:DatabaseObservation>

### Full-Text Search

- <doc:FullTextSearch>

### Combine Publishers

- ``DatabasePublishers``
